module func_sharing_b 
#(
   parameter N = 8
)(
   input          s,
   input  [N-1:0] a, b,
   output [N-1:0] f
);

reg  [N:0] src0, src1;
wire [N:0] tmp;

always @* begin
   if (s) begin
      src0 = {a, 1'b1};
      src1 = {~b, 1'b1};
   end
   else begin
      src0 = {a, 1'b1};
      src1 = {b, 1'b0};
   end
end

assign tmp = src0+src1;
assign f = tmp[N:1];

endmodule