module op_sharing_ex3b 
#(
   parameter N = 8
)(
   input  [1:0]   s,
   input  [N-1:0] a, b, c, d, e,
   output [N-1:0] f,
   output         ov
);

reg  [N-1:0] src0, src1;
wire [N:0]   tmp;

always @* begin
   case (s)
      2'b01: begin
         src0 = a;
         src1 = b;
      end
      2'b10: begin
         src0 = a;
         src1 = c;
      end
      default: begin
         src0 = d;
         src1 = e;
      end
   endcase
end

assign tmp = src0 + src1;
assign f = tmp[N-1:0];
assign ov = tmp[N];

endmodule