module op_sharing_ex4b 
#(
   parameter N = 8
)(
   input          s,
   input  [N-1:0] a, b, c, d,
   output [N-1:0] x, y,
   output         x_ov, y_ov
);

reg  [N-1:0] src0, src1;
reg  [N:0]   x_tmp, y_tmp;
wire [N:0]   sum;

always @* begin
   if (s) begin
      src0 = a;
      src1 = b;
      x_tmp = sum;
      y_tmp = 0;
   end
   else begin
      src0 = c;
      src1 = d;
      x_tmp = 1;
      y_tmp = sum;
   end
end

assign sum = src0+src1;

assign x = x_tmp[N-1:0];
assign x_ov = x_tmp[N];

assign y = y_tmp[N-1:0];
assign y_ov = y_tmp[N];

endmodule