module sseg_decoder_seq (
   input            clk,
   input            rstb,
   input      [3:0] num,
   input            dp,
   output reg [7:0] sseg
);

reg        dp_reg;
reg  [3:0] num_reg;
wire [7:0] sseg_next;

always @* begin
   case (num_reg)
      4'd0: sseg_next[6:0] = 7'b111_1110;
      4'd1: sseg_next[6:0] = 7'b011_0000; 
      4'd2: sseg_next[6:0] = 7'b110_1101; 
      4'd3: sseg_next[6:0] = 7'b111_1001; 
      4'd4: sseg_next[6:0] = 7'b011_0011; 
      4'd5: sseg_next[6:0] = 7'b101_1011; 
      4'd6: sseg_next[6:0] = 7'b101_1111; 
      4'd7: sseg_next[6:0] = 7'b111_0000; 
      4'd8: sseg_next[6:0] = 7'b111_1111; 
      default: sseg_next[6:0] = 7'b111_1011; // 4’d9
   endcase
   sseg_next[7] = dp_reg;
end

always @(posedge clk or negedge rstb) begin
   if (!rstb) begin
      dp_reg  <= 1'b0;
      num_reg <= 4'd0;
      sseg    <= 8'd0;
   end
   else begin
      dp_reg  <= dp;
      num_reg <= num;
      sseg    <= sseg_next;
   end
end

endmodule